#!/usr/bin/env python

import os
import re
import sys
parent = os.path.abspath(os.path.join(os.path.abspath(os.path.dirname(__file__)),'..','..'))
sys.path.append(parent)

configuration = os.path.join(parent,'conf','irrpt.conf')
expr_file = re.compile('''\$cfg\[["'](.*?)["']\]\[["'](.*?)["']\]\s*=\s*['"]?(.*?)['"]?;''')
expr_path = re.compile('''\$cfg\[["'](.*?)["']\]\[["'](.*?)["']\]\s*=\s*\$cfg\['(.*?)'\]\['(.*?)'\]\s.\s*['"](.*?)['"];''')
expr_php = re.compile('^<\?.*|.*?>$')

try:
	f = open(configuration,'r')
except:
	print >> sys.stderr, 'Could not find configuration file %s' % configuration
	sys.exit(1)

cfg = {}

index = 0
try:
	for line in f.readlines():
		index += 1
		line = line.strip()
		
		if line == '':
			continue
		
		if line[0] == '#':
			continue
		
		match = expr_php.search(line)
		if match:
			continue
		
		match = expr_path.search(line)
		if match:
			app = match.group(1)
			opt = match.group(2)
			k1 = match.group(3)
			k2 = match.group(4)
			val = match.group(5)
			path = cfg[k1][k2]
			dest = os.path.join(path,val)
			if not cfg.has_key(app):
				cfg[app] = {}
			cfg[app][opt] = dest
			continue
		
		match = expr_file.search(line)
		if match:
			app = match.group(1)
			opt = match.group(2)
			val = match.group(3)
			if not cfg.has_key(app):
				cfg[app] = {}
			cfg[app][opt] = val
			continue
		
		raise
except:
	print >> sys.stderr, 'could not parse %s at line %d' % (configuration,index)
	sys.exit(1)

#print cfg

if __name__ == '__main__':
	print cfg