#!/usr/bin/env python

import time
import os
import sys
parent = os.path.abspath(os.path.join(os.path.abspath(os.path.dirname(__file__)),'..'))
sys.path.append(parent)

def parse (configs=None):
	if configs == None:
		configs = [os.path.join(parent,'..','conf','ripe.msg')]
	
	header = 'unknown'
	display = {'unknown' : []}
	for config in configs:
		try:
			f = open(config,'r')
			for line in f.readlines():
				line = line.strip()
				if len(line) == 0:
					continue
				if line[0] == '#':
					continue
				if line[0] == '[' and line [-1] == ']':
					header = line[1:-1]
					if header not in display.keys():
						display[header] = []
					continue
				display[header].append(line)
		except:
			pass
	return display

def secret ():
	f = None
	name = os.path.join(parent,'..','conf','ripe.secret')
	try:
		f = open(name)
		s = f.readline().strip()
		f.close()
	except:
		s = ''
		if f != None:
			f.close
	return s

if __name__ == '__main__':
	sys.path.append(parent)
	from conf.param import option
	
	def usage (problem):
		print >> sys.stderr , 'usage: %s [files]' % sys.argv[0]
		print >> sys.stderr , problem
		sys.exit(1)

	folders = option.get('cmdline',None)
	display = parse(folders)
	
	if not display.has_key('header') or not display.has_key('footer'):
		usage('no configuration file found')
	
	print '\n'.join(display['header']) % {'generated':time.strftime("%Y%m%d %H:%M:%S")}
	print '\n'.join(display['footer'])
	sys.exit(0)
