#!/usr/bin/env python
import os

class CVS:
	def __init__ (self,cvs,cvsroot,base,db,diff_param,diff_format):
		os.environ['CVSROOT'] = cvsroot
		self.cvs = cvs
		self.cfg = cfg
		self.base = base
		self.db = db
		self.diff_param = diff_param
		self.diff_format = diff_format
	
	def get_diff (f,rev):
		result = []
		
		if not os.path.exists(self.cvs) or not os.access(self.cvs,os.R_OK|X_OK):
			return False
		
		if not file.path.exits(f) and not os.access(f,R_OK):
			return False
		
		command = ' '.join([self.cvs,'diff',self.diff_param,'-r',rev['old'],rev['new'],f])
		
		cvscmd = os.popen(command,'r')
		# Check that this is well the interface for popen (return None or raise)
		if cvscmd == None:
			return False
		
		format = self.diff_format.lower()
		
		for line in cvscmd.readlines():
			line = line.strip()
			if format == 'english' or format == 'plusminus':
				tmp = line[0:3]
				if tmp == '+++' or tmp == '---' or tmp == '@@':
					continue
			elif format == 'english':
				if tmp[0] == '+':
					result.append('Add ' + line[1:])
				if tmp[0] == '-':
					result.append('Remove ' + line[1:])
			elif format == 'plusminus':
				result.append(line)
			else:
				result.append(line.replace(self.base,''))
		
		cvscmd.close()
		return '\n'.join(result)

	def get_complete (self,f):
		result = []
		
		try:
			routes = open(f,'r')
			
			for line in routes.readlines():
				result.append(line.strip())
		except:
			return False
		
		routes.close()
		return '\n'.join(result)
	
	def update (self,f):
		result = []
		rev = {}
	
		if not os.path.exists(self.cvs) or not os.access(self.cvs,os.R_OK|X_OK):
			return False
	
		if not file.path.exits(f) and not os.access(f,R_OK):
			return False
		
		# XXX: Check return of this
		os.chdir(self.db)
		
		command = ' '.join([self.cvs,'add',f,'2>&1'])
	
		cvscmd = os.popen(command,'r')
		# Check that this is well the interface for popen (return None or raise)
		if cvscmd == None:
			return False
	
		for line in cvscmd.readlines():
			line = line.strip()
			
			if line.find('already exists') >= 0:
				tmp = line.split(' ')
				rev['old'] = tmp[8]
				rev['new'] = tmp[8]
		
		close(cvscmd)

		command = ' '.join([self.cvs,'commit','-m','update',f])
		
		cvscmd = os.popen(command,'r')
		# Check that this is well the interface for popen (return None or raise)
		if cvscmd == None:
			return False
	
		for line in cvscmd.readlines():
			line = line.strip()
			
			if line.find('initial revision') >= 0:
				tmp = line.split(':')
				rev['old'] = '0.00'
				rev['new'] = tmp[1].strip()
				break
			
			if line.find('new revision') >= 0:
				tmp = line.split(':')
				rev['old'] = tmp[2].strip()
				tmp = tmp.split(';')
				rev['new'] = tmp[0].strip()
				break

		cvscmd.close()
