#!/usr/bin/env python

import time
import os
import sys

# router:
# The name, of part of the name you want to match, ['*'] for all
def parse (stdin,routers,display):
	matched = []
	matches = []

	for line in stdin.readlines():
		try:
			router,atype,group,asn,announce,src,dest,macro,mail,name = line[:-1].split('|')
		except:
			print >> sys.stderr, 'wrong stdin data'
			sys.exit(1)

		if not atype in display:
			continue
		if macro in ['ANY','NOT ANY']:
			continue
		
		for r in routers:
			if router.find(r) == 0 or routers == ['*']:
				matches.append(router)
				try:
					matched.append((router,atype,asn))
				except:
					matched = [(router,atype,asn)]
		
	return [set(matches),matched]

if __name__ == '__main__':
	parent = os.path.abspath(os.path.join(os.path.abspath(os.path.dirname(__file__)),'..'))
	sys.path.append(parent)
	from conf.param import option
	
	def usage (problem):
		print >> sys.stderr , 'usage: %s [option]' % sys.argv[0]
		print >> sys.stderr , problem
		sys.exit(1)

	display_options = ['transit','peer','customer']
	display = []
	for d in display_options:
		if option.has_key(d):
			display.append(d)
	if display == []:
		display = display_options
	
	routers = option.get('cmdline',['*'])
	[names,asns] = parse(sys.stdin,routers,display)

	if len(names) > 1 and routers != ['*']:
		print >> sys.stderr, 'more than one router name found %s' % ' '.join(names)
	if len(names) < 1:
		print >> sys.stderr, 'no router(s) with than name found %s' % ' '.join(routers)
	
	for asn in asns:
		if option.has_key('extensive'):
			print '|'.join(asn)
		else:
			print asn[2]
	
	sys.exit(0)
