#!/usr/bin/env python

import time
import os
import sys


def parse(stdin,display):
	seen = {}
	issue = False

	for line in stdin.readlines():
		try:
			router,atype,group,asn,announce,src,dest,macro,mail,name = line[:-1].split('|')
		except:
			print >> sys.stderr, 'invalid stdin input'
			sys.exit(1)

		if not atype in display:
			continue
		
		if macro in ['ANY','NOT ANY']:
			continue
			
		if seen.has_key(asn) > 0:
			done = False
			old_macro = seen[asn][0]
			old_mail = seen[asn][1]
			old_announce = seen[asn][3]

			if old_macro != macro:
				if old_macro != '' and macro != '':
					print >> sys.stderr, 'inconsistant policy for asn %s : %s and %s' % (asn,macro,old_macro)
					issue = True

				if old_macro == '':
					old_macro,mail,name,announce = seen[asn]
					seen[asn] = macro,mail,name,announce
					done = True

			if old_mail != mail:
				if old_mail != '' and mail != '':
					print >> sys.stderr, 'different contact for asn %s : %s and %s' % (asn,mail,old_mail)
				if old_mail == '':
					macro,old_mail,name,announce = seen[asn]
					seen[asn] = macro,mail,name,announce
					done = True

			if old_announce != announce:
				print >> sys.stderr, 'different announcement for asn %s : %s and %s' % (asn,announce,old_announce)

			if done:
				continue

		seen[asn] = (macro,mail,name,announce)
	return seen

if __name__ == '__main__':
	parent = os.path.abspath(os.path.join(os.path.abspath(os.path.dirname(__file__)),'..'))
	sys.path.append(parent)
	from conf.param import option
	
	def usage (problem):
		print >> sys.stderr , 'usage: %s [option]' % sys.argv[0]
		print >> sys.stderr , problem
		sys.exit(1)

	display_options = ['transit','peer','customer']
	display = []
	for d in display_options:
		if option.has_key(d):
			display.append(d)
	if display == []:
		display = display_options
	
	seen = parse(sys.stdin,display)
	
	print """
##############################################################################
# ASN   IRR Object (AS-SET/AUT-NUM)       Update Email         Comment
##############################################################################
"""
	
	asns = seen.keys()
	asns.sort()
	for asn in asns:
		macro,mail,name,announce = seen[asn]
		print "%-7s %-20s %-35s # %s [%s]" % (asn,macro,mail,name,announce)

	sys.exit(0)

