#!/usr/bin/env python

import os
import re

def locate (directory):
	expr_file = re.compile('(.*)_juniper.conf_(\d*)_(\d*)')

	last = {}

	for files in os.walk(directory):
		directory = files[0]
		for file in files[2]:
			match = expr_file.match(file)
			if match:
				router = match.group(1)
				date = int(match.group(2))
				time = int(match.group(3))
				if last.has_key(router):
					newest_date = last[router][0]
					if date < newest_date:
						continue
					elif date == newest_date:
						if time < last[router][1]: continue
				last[router] = (date,time,directory,file)

	routers = last.keys()
	if len(routers) == 0:
		return []

	confs = []
	for router in routers:
		date,time,directory,file = last[router]
		confs.append(os.path.join(directory,file))
	
	return confs

if __name__ == '__main__':
	import sys
	parent = os.path.abspath(os.path.join(os.path.abspath(os.path.dirname(__file__)),'..'))
	sys.path.append(parent)
	from conf.param import option
	
	def usage ():
		print >> sys.stderr, 'usage: %s folder' % option['program']
		sys.exit(1)
		
	try: directory = option['folder'][0]
	except: usage()

	routers = locate(directory)
	if routers == []:
		print >> sys.stderr, 'could not find any junos configuration'
		sys.exit(1)
	
	for r in routers:
		if option.has_key('dump'):
			try:
				f = open(r,'r')
				for line in f:
					sys.stdout.write(line)
				f.close()
			except:
				print >> sys.stderr, 'could not display the content of %s' % r
				sys.exit(1)
		else:
			print r
	sys.exit(0)

