import ip

class CIDR:
	def __init__ (self,network,bits):
		if type(network) is type(""):
			self.network = ip.todecimal(network)
		else:
			self.network = network
		self.bits = int(bits)
		self.size = ip.tosize(bits)
		self.next = self.network + self.size
		self.broadcast = self.next - 1
		if not ip.aligned(self.network,self.size):
			raise "invalid CIDR"

	def __str__ (self):
		return ip.toip(self.network) + "/" + str(self.bits)

	def divide (self,size):
		if size > self.size:
			raise "no enough consecutive IP to divide"
		bits = ip.tobits(size)
		if ip.israngesize(size):
			for net in xrange(self.network,self.next,size):
				yield CIDR (net,bits)
		else:
			raise "Invalid number of IP"
	
	def container (self):
		size = self.size * 2
		network = int(self.network/size)
		return CIDR(network*size,size)
